package main

import (
	"flag"
	"fmt"
	"log"
	"os"

	"gonum.org/v1/gonum/graph/encoding/dot"
)

func main() {
	f := flag.String("f", "", "graphviz file")
	flag.Parse()

	if *f == "" {
		log.Fatal("-f is required")
	}

	contents, err := os.ReadFile(*f)
	if err != nil {
		log.Fatal(err)
	}

	g := newProjectNetwork()
	err = dot.Unmarshal(contents, g)
	if err != nil {
		log.Fatal(err)
	}

	err = g.calculateTimes()
	if err != nil {
		log.Fatal(err)
	}

	data, err := dot.Marshal(g, "", "", "\t")
	if err != nil {
		log.Fatal(err)
	}

	fmt.Println(string(data))
}
